# encoding: UTF-8

# all dimensions are in milimeters!


module Etti
    module PropertyEditorData
        include GetText
        GetText.bindtextdomain 'etti', :path => Etti::LOCALE_PATH

        DEFAULT_TEXTS_TEXT = ''
        DEFAULT_TEXTS_POS_X = 0.0
        DEFAULT_TEXTS_POS_Y = 0.0
        DEFAULT_TEXTS_SIZE = 4.0
        DEFAULT_TEXTS_ROTATION = 0.0
        DEFAUTL_TEXTS_COLOR = [0.0, 0.0, 0.0, 1.0]

        TEXTS_PROPS = [
            {label: _('text'), type: :entry, useDefault: false,
              id0: 'text', default0: DEFAULT_TEXTS_TEXT},

            {label: _('position'), type: :sSpin, useDefault: false,
             id0: 'pos_x', id1: 'pos_y', range: -1000.0..1000.0, step: 0.05,
             default0: DEFAULT_TEXTS_POS_X, default1: DEFAULT_TEXTS_POS_Y, synced: false},

            {label: _('size'), type: :spin,   useDefault: false,
              id0: 'size', range: 0.1..100.0, step: 0.05,
              default0: DEFAULT_TEXTS_SIZE},

            {label: _('rotation'), type: :spin,   useDefault: true,
              id0: 'rotation', range: 0.0..360.0, step: 1.0,
              default0: DEFAULT_TEXTS_ROTATION},
            
            {label: _('color'), type: :color, useDefault: true,
              id0: 'color', default0: DEFAUTL_TEXTS_COLOR},
         ]


        DEFAULT_DATA_SHOW_AS = 0
        DEFAULT_QR_WIDTH = 10
        DEFAULT_QR_HEIGHT = 10
        DEFAULT_QR_VERSION = 1
        DEFAULT_QR_ERROR_CORRECTION = 1
        DEFAULT_QR_ENCODING = 3

        DATA_PROPS = [
            {label: _('position'), type: :sSpin, useDefault: false,
             id0: 'pos_x', id1: 'pos_y', range: -1000.0..1000.0, step: 0.05,
             default0: DEFAULT_TEXTS_POS_X, default1: DEFAULT_TEXTS_POS_Y, synced: false},

            {label: _('rotation'), type: :spin, useDefault: true,
              id0: 'rotation', range: 0.0..360.0, step: 1.0,
              default0: DEFAULT_TEXTS_ROTATION},

            {label: _('color'), type: :color, useDefault: true,
              id0: 'color', default0: DEFAUTL_TEXTS_COLOR},

            {label: _('show as'), type: :radioRevealer,
             id0: 'showAs', default0: DEFAULT_DATA_SHOW_AS,
                revealSections: [

                    {section: 'text',
                        data: [
                            {label: _('size'), type: :spin,   useDefault: false,
                              id0: 'size', range: 0.1..100.0, step: 0.05,
                              default0: DEFAULT_TEXTS_SIZE}
                        ]},

                     {section: 'QR-Code',
                        data: [
                            {label: _('display size'), type: :sSpin, useDefault: false,
                             id0: 'qrWidth', id1: 'qrHeight', range: 1.0..1000.0, step: 0.1,
                             default0: DEFAULT_QR_WIDTH, default1: DEFAULT_QR_HEIGHT, synced: true},

                            {label: _('version'), type: :spin, useDefault: false,
                             id0: 'qrVersion', range: 1..40, step: 1, default0: DEFAULT_QR_VERSION},

                            {label: _('correction'), type: :combo, useDefault: true,
                             id0: 'qrErrorCorrection', default0: DEFAULT_QR_ERROR_CORRECTION,
                             entries: ['low', 'medium', 'quarter', 'high']},

                            {label: _('encoding'), type: :combo, useDefault: true,
                             id0: 'qrEncoding', default0: DEFAULT_QR_ENCODING,
                             entries: ['automatic', 'numeric', 'alphanumeric', 'ascii', 'kanji']}
                        ]
                    }
                ]
             }
         ]


         # this is a dummy entry if no element is selected
        NONE_PROPS = []
    end
end
